# apache-modperl RPM SPEC 

%define apachever 1.3.6
%define modperlver 1.19

Summary: The most widely used Web server on the Internet, with static mod_perl support.
Name: apache_modperl
Version: %{apachever}-%{modperlver} 
Release: 1
Group: System Environment/Daemons

# apache sources
Source: ftp://ftp.apache.org/apache/dist/apache_%{apachever}.tar.gz
Source1: apache-index.html
Source2: poweredby.gif
Source3: httpd.init
Source4: apache.logrotate
Source5: apache-access.conf
Source6: apache-httpd.conf
Source7: apache-srm.conf
Source8: mod_bandwidth.c
# mod_perl sources
Source9: http://www.perl.com/CPAN/by-module/Apache/mod_perl-%{modperlver}.tar.gz

Patch0: apache_1.3.6-redhat.patch
Patch1: apache_1.3.6-apxs.patch
Patch2: apache_1.3.4-srvroot.patch
Patch3: apache_1.3.3-nondbm.patch

Copyright: Freely distributable and usable
BuildRoot: /var/tmp/apache-modperl-root
Requires: /etc/mime.types perl >= 5.004-4
Prereq: /sbin/chkconfig, /bin/mktemp, mailcap, grep, textutils
Provides: webserver

%description
Apache is a powerful, full-featured, efficient and freely-available
Web server. Apache is also the most popular Web server on the
Internet.

This package will install the Apache Web server on your machine.
It includes statically compiled mod_perl module.  

mod_perl is a powerful Apache module that enables the use of the PERL
language within HTML files and more.                         

%package devel
Group: Development/Libraries
Summary: Module development tools for the Apache web server version 1.3.1.
Obsoletes: secureweb-devel

%description devel
The apache-devel package contains the source code for the Apache 1.3.1
Web server and the APXS binary you'll need to build Dynamic Shared Objects
(DSOs) for Apache.

If you are installing the Apache Web server version 1.3.1 or later, and
you want to be able to compile or develop additional modules for Apache,
you'll need to install this package.

%prep
# first, unpack apache.  We unpack it BELOW a toplevel directory "secureweb"
%setup -q -n apache_%{apachever}
%patch0 -p1 -b .redhat
%patch1 -p1 -b .apxs
%patch2 -p1 -b .srvroot
%patch3 -p1 -b .nondbm

# unpack mod_perl
%setup -T -b 9 -q -n mod_perl-%{modperlver}

%build
# first, prepare mod_perl
##cd ./mod_perl-%{modperlver}

perl Makefile.PL \
    APACHE_SRC=../apache_%{apachever}/src \
    DO_HTTPD=1 \
    USE_APACI=1 \
    PREP_HTTPD=1 \
    EVERYTHING=1 

make

# now, do the apache configuration
cd ../apache_%{apachever}

OPTIM="$RPM_OPT_FLAGS" \
	./configure --prefix=/usr \
	--with-layout=RedHat \
	--add-module=%{SOURCE8} \
	--enable-module=all \
	--enable-shared=max \
	--disable-rule=WANTHSREGEX \
	--disable-module=auth_dbm \
	--with-perl=/usr/bin/perl \
        --activate-module=src/modules/perl/libperl.a
make
	
%install
rm -rf $RPM_BUILD_ROOT

# install the mod_perl files first
#cd ../mod_perl-%{modperlver}

make pure_install PREFIX=$RPM_BUILD_ROOT/usr
mkdir -p $RPM_BUILD_ROOT/home/httpd/htdocs/manual/mod
install -m 644 htdocs/manual/mod/mod_perl.html \
        $RPM_BUILD_ROOT/home/httpd/htdocs/manual/mod

PACKLIST=$RPM_BUILD_ROOT/usr/lib/perl5/site_perl/%{buildarch}-linux/auto/mod_perl/.packlist
mv $PACKLIST $PACKLIST.old
sed -e "s|$RPM_BUILD_ROOT||g" < $PACKLIST.old > $PACKLIST
rm -f $PACKLIST.old

# mathforum - sasha - Thu Apr 15 17:45:40 EDT 1999
# exclude mod_perl.html to avoid having it twice in the file list
find $RPM_BUILD_ROOT -type f -o -type l | \
        sed -e "s|$RPM_BUILD_ROOT||g" | \
	grep -v mod_perl.html >  modperl-file-list.lst
cd faq; make; cd ..

# now install the apache stuff
cd ../apache_%{apachever}
make install root=$RPM_BUILD_ROOT

# remove apachectl; we have our own SYSV init stuff
rm $RPM_BUILD_ROOT/usr/sbin/apachectl

# rename htdocs dir to html dir 
mv $RPM_BUILD_ROOT/home/httpd/htdocs $RPM_BUILD_ROOT/home/httpd/html

# install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 $RPM_SOURCE_DIR/httpd.init \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/httpd

for I in 0 1 2 6; do
	mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc$I.d
	ln -s ../init.d/httpd $RPM_BUILD_ROOT/etc/rc.d/rc$I.d/K15httpd
done
for I in 3 5; do
	mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc$I.d
	ln -s ../init.d/httpd $RPM_BUILD_ROOT/etc/rc.d/rc$I.d/S85httpd
done

# install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/apache.logrotate \
	$RPM_BUILD_ROOT/etc/logrotate.d/apache

ln -s ../../var/log/httpd $RPM_BUILD_ROOT/etc/httpd/logs
ln -s ../../usr/lib/apache $RPM_BUILD_ROOT/etc/httpd/modules

install -m644 $RPM_SOURCE_DIR/apache-index.html \
        $RPM_BUILD_ROOT/home/httpd/html/index.html
install -m644 $RPM_SOURCE_DIR/poweredby.gif \
	$RPM_BUILD_ROOT/home/httpd/html

# replace Apache's default config files with our own versions
install -m644 $RPM_SOURCE_DIR/apache-access.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/access.conf

install -m644 $RPM_SOURCE_DIR/apache-httpd.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/httpd.conf

install -m644 $RPM_SOURCE_DIR/apache-srm.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/srm.conf

# install apache source code for devel package
#mkdir -p $RPM_BUILD_ROOT/usr/src
#tar xzf $RPM_SOURCE_DIR/apache_%{version}.tar.gz -C $RPM_BUILD_ROOT/usr/src
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl5" | \
	xargs perl -pi -e "s|/usr/local/bin/perl5|/usr/bin/perl|g;"
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl" | \
	xargs perl -pi -e "s|/usr/local/bin/perl|/usr/bin/perl|g;"

%clean
rm -rf $RPM_BUILD_ROOT
#rm -f modperl-file-list.lst

%post
/sbin/chkconfig --add httpd
[ -f /etc/mime.types ] || exit 0
# safely add .htm to mime types if it is not already there
TEMPTYPES=`/bin/mktemp /tmp/mimetypes.XXXXXX`
[ -z "$TEMPTYPES" ] && {
  echo "could not make temporary file, htm not added to /etc/mime.types" >&2
  exit 1
}
( grep -v "^text/html"  /etc/mime.types
  types=$(grep "^text/html" /etc/mime.types | cut -f2-)
  echo -en "text/html\t\t\t"
  for val in $types ; do
      if [ "$val" = "htm" ] ; then
          continue
      fi
      echo -n "$val "
  done
  echo "htm"
) > $TEMPTYPES
cat $TEMPTYPES > /etc/mime.types && rm -f $TEMPTYPES

%preun
if [ $1 = 0 ]; then
   /sbin/chkconfig --del httpd
   rm -fr /var/log/httpd/*

fi

# modperl files
%files -f modperl-file-list.lst
%doc README INSTALL faq/*.html eg
%doc ToDo apache-modlist.html
%dir /usr/lib/perl5/site_perl/%{buildarch}-linux/auto/Apache
%dir /usr/lib/perl5/site_perl/%{buildarch}-linux/auto/Apache/Symbol
%dir /usr/lib/perl5/site_perl/Apache/Constants
%dir /usr/lib/perl5/site_perl/%{buildarch}-linux/auto/mod_perl
%dir /usr/lib/perl5/site_perl/Apache
# apache files
%defattr(-,root,root)
%dir /etc/httpd/conf
%config /etc/httpd/conf/access.conf
%config /etc/httpd/conf/srm.conf
%config /etc/httpd/conf/httpd.conf
%config /etc/httpd/conf/magic

/etc/httpd/logs
/etc/httpd/modules
%config /etc/logrotate.d/apache
%config /etc/rc.d/init.d/httpd
%config(missingok) /etc/rc.d/rc3.d/S85httpd
%config(missingok) /etc/rc.d/rc5.d/S85httpd
%config(missingok) /etc/rc.d/rc0.d/K15httpd
%config(missingok) /etc/rc.d/rc1.d/K15httpd
%config(missingok) /etc/rc.d/rc2.d/K15httpd
%config(missingok) /etc/rc.d/rc6.d/K15httpd

%dir /home/httpd
%dir /home/httpd/cgi-bin
%dir /home/httpd/html
%config(noreplace) /home/httpd/html/index.html
/home/httpd/html/poweredby.gif
/home/httpd/html/manual
/home/httpd/icons

/usr/lib/apache
/usr/man/*/*
/usr/sbin/ab
/usr/sbin/httpd
/usr/sbin/logresolve
/usr/sbin/rotatelogs
/usr/bin/*

%attr(-,nobody,nobody) %dir /var/cache/httpd
%dir /var/log/httpd

%files devel
%defattr(-,root,root)
/usr/include/apache
/usr/sbin/apxs
#/usr/src/apache_%{version}

%changelog
* Fri Mar 26 1999 Preston Brown <pbrown@redhat.com>
- updated log rotating scripts to not complain if logs aren't present.

* Thu Mar 25 1999 Preston Brown <pbrown@redhat.com>
- fixed up path to perl

* Wed Mar 24 1999 Preston Brown <pbrown@redhat.com>
- updated init script to conform to new standards
- upgraded to 1.3.6, fixed apxs patch

* Mon Mar 22 1999 Preston Brown <pbrown@redhat.com>
- clean up logfiles on deinstallation

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Fri Mar 12 1999 Cristian Gafton <gafton@redhat.com>
- added mod_bandwidth
- updated to 1.3.4
- prereq mailcap

* Fri Dec 18 1998 Cristian Gafton <gafton@redhat.com>
- added patch to disable building support for ndbm
- build against glibc 2.1

* Mon Oct 12 1998 Cristian Gafton <gafton@redhat.com>
- updated to 1.3.3 to catch up with bug fixes
- added the /usr/bin/* binaries to the spec file list

* Fri Sep 25 1998 Cristian Gafton <gafton@redhat.com>
- change ownership of cache dir to nobody
- added "Red Hat" to the server string
- updated to version 1.3.2
- fixed all references to httpsd in config files

* Fri Sep 04 1998 Cristian Gafton <gafton@redhat.com>
- small fixes to the spec file
- patch to handle correctly the -d <newroot> option
- leave out the .usr.src.apache_%{version} for now

* Thu Sep 03 1998 Preston Brown <pbrown@redhat.com>
- patched apxs not to bomb out if it can't find httpd

* Wed Sep 02 1998 Preston Brown <pbrown@redhat.com>
- upgraded to apache 1.3.1.
- Heavy rewrite.
- changed providing a_web_server to just webserver.  Humor is not an option.

* Mon Aug 10 1998 Erik Troan <ewt@redhat.com>
- updated to build as non-root user
- added patch to defeat header dos attack

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed May 06 1998 Cristian Gafton <gafton@redhat.com>
- fixed the default config files to be more paranoid about security

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- fixed init script
- added index.htm to the list of acceptable indexes

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- updated to 1.2.6
- added post script to install htm extension for text/html into
  /etc/mime.types

* Wed Apr 22 1998 Michael K. Johnson <johnsonm@redhat.com>
- enhanced sysv init script

* Tue Jan 06 1998 Erik Troan <ewt@redhat.com>
- updated to 1.2.5, which includes many security fixes

* Wed Dec 31 1997 Otto Hammersmith <otto@redhat.com>
- fixed overkill on http.init stop

* Wed Dec 31 1997 Erik Troan <ewt@redhat.com>
- added patch for backslash DOS attach

* Thu Nov 06 1997 Donnie Barnes <djb@redhat.com>
- added htdigest binary to file list

* Mon Nov 03 1997 Donnie Barnes <djb@redhat.com>
- made the default index.html be config(noreplace) so we no longer
  blow away other folks' index.html

* Wed Oct 29 1997 Donnie Barnes <djb@redhat.com>
- added chkconfig support
- added restart|status options to initscript
- renamed httpd.init to httpd

* Tue Oct 07 1997 Elliot Lee <sopwith@redhat.com>
- Redid spec file, patches, etc. from scratch.
